// MyExtDataModel.cpp: implementation of the CMyExtDataModel class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CustomMSample.h"
#include "MyExtDataModel.h"
#include "MyCorsssLineShape.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(CMyExtDataModel, CFOMultiPageModel, 0)

CMyExtDataModel::CMyExtDataModel()
{

}

CMyExtDataModel::~CMyExtDataModel()
{

}

CString CMyExtDataModel::GetUniqueName(UINT nType)
{
	CString strReturn;
	strReturn = "nLine";
	if(nType == MY_LINE_TYPE)
	{
		return strReturn;
	}
	else
	{
		return CFOMultiPageModel::GetUniqueName(nType);
	}
}

CString CMyExtDataModel::GetUniqueCaption(UINT nType)
{
	CString strReturn;
	strReturn = "Line";
	if(nType == MY_LINE_TYPE)
	{
		return strReturn;
	}
	else
	{
		return CFOMultiPageModel::GetUniqueCaption(nType);
	}
}

CFODrawShape *CMyExtDataModel::DoCreateShapeByType(UINT m_drawshape,CRect &rcCreate,CString strFileName,CFOToolBoxItem *pCurItem)
{
	CFODrawShape *pReturn = NULL;
	CString strCaption;
	CString strName;
	strCaption = "";
	strName = "";
	CPoint ptTrack = rcCreate.TopLeft();
	if(m_drawshape != FO_COMP_NONE)
	{
		CRect rc(rcCreate);
		rc.NormalizeRect();
		if(rc.IsRectEmpty()||(rc.Width()<=10 && rc.Height()<20))
		{
			if(m_drawshape == MY_LINE_TYPE)
			{
				rc = CRect(ptTrack.x-70,ptTrack.y-70,ptTrack.x+70,ptTrack.y+70);
			}
		}
		if(m_drawshape == MY_LINE_TYPE)
		{
			pReturn = new CMyCorsssLineShape;
			pReturn->AddRef();
			pReturn->Create(rc,"");
			strCaption = GetUniqueCaption(pReturn->GetType());
			strName = GetUniqueName(pReturn->GetType());
			pReturn->SetObjectCaption(strCaption);
			pReturn->SetObjectName(strName);
		}
		else
		{
			pReturn = CFOMultiPageModel::DoCreateShapeByType(m_drawshape,rcCreate,strFileName);
		}
	}
	return pReturn;

}
