// CustomMSampleView.cpp : implementation of the CCustomMSampleView class
//

#include "stdafx.h"
#include "CustomMSample.h"
#include "MyCorsssLineShape.h"
#include "CustomMSampleDoc.h"
#include "CustomMSampleView.h"
#include "MyExtDataModel.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomMSampleView

IMPLEMENT_DYNCREATE(CCustomMSampleView, CFOMultiPageView)

BEGIN_MESSAGE_MAP(CCustomMSampleView, CFOMultiPageView)
	//{{AFX_MSG_MAP(CCustomMSampleView)
	ON_WM_CREATE()
	ON_COMMAND(ID_BACK_COLOR, OnBackColor)
	ON_UPDATE_COMMAND_UI(ID_BACK_COLOR, OnUpdateBackColor)
	ON_COMMAND(ID_TEXT_COLOR, OnTextColor)
	ON_UPDATE_COMMAND_UI(ID_TEXT_COLOR, OnUpdateTextColor)
	ON_COMMAND(ID_NEW_SHAPE, OnNewShape)
	ON_UPDATE_COMMAND_UI(ID_NEW_SHAPE, OnUpdateNewShape)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFOMultiPageView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFOMultiPageView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFOMultiPageView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomMSampleView construction/destruction

CCustomMSampleView::CCustomMSampleView()
{
	// TODO: add construction code here

}

CCustomMSampleView::~CCustomMSampleView()
{
}

BOOL CCustomMSampleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFOMultiPageView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CCustomMSampleView drawing

void CCustomMSampleView::OnDraw(CDC* pDC)
{
	CCustomMSampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// Form++ Library Add line.
	Draw(pDC);
	// TODO: add draw code for native data here
}

void CCustomMSampleView::OnInitialUpdate()
{
	// Form++ Library Add line.
	SetMultiModel(GetDocument()->m_pMultiModel);
	CFOMultiPageView::OnInitialUpdate();
}

/////////////////////////////////////////////////////////////////////////////
// CCustomMSampleView printing

BOOL CCustomMSampleView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return CFODrawView::OnPreparePrinting(pInfo);
}

void CCustomMSampleView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: add extra initialization before printing
	// Form++ Library Add line.
	CFOMultiPageView::OnBeginPrinting(pDC,pInfo);
}

void CCustomMSampleView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CCustomMSampleView diagnostics

#ifdef _DEBUG
void CCustomMSampleView::AssertValid() const
{
	CFOMultiPageView::AssertValid();
}

void CCustomMSampleView::Dump(CDumpContext& dc) const
{
	CFOMultiPageView::Dump(dc);
}

CCustomMSampleDoc* CCustomMSampleView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCustomMSampleDoc)));
	return (CCustomMSampleDoc*)m_pDocument;
}
#endif //_DEBUG


void CCustomMSampleView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CFOMultiPageView::OnPrint(pDC, pInfo);
}

void CCustomMSampleView::OnBackColor() 
{
	// TODO: Add your command handler code here
	if(m_listSelectComp.GetCount() == 1)
	{
        CFODrawShape *pObj = GetCurrentSelectShape();
        if(pObj != NULL)
        {
			COLORREF crText;
			COLORREF crBack;
			crText = pObj->GetFontColor();
			CColorDialog dlg(pObj->GetBkColor(), CC_FULLOPEN | CC_ANYCOLOR);
			if(dlg.DoModal() == IDOK)
			{
				crBack = dlg.GetColor();
				CFOColorChangeAction* pCmd = new CFOColorChangeAction(GetCurrentModel(),pObj,crBack,crText);
				GetCurrentModel()->Do(pCmd,TRUE);
			}
        }
	}
	else if(m_listSelectComp.GetCount() < 1)
	{
		COLORREF crText;
		COLORREF crBack;
		crText = GetCurrentModel()->GetFontColor();
		CColorDialog dlg(GetCurrentModel()->GetBkColor(), CC_FULLOPEN | CC_ANYCOLOR);
		if(dlg.DoModal() == IDOK)
		{
			crBack = dlg.GetColor();
			CFOFormColorChangeAction* pCmd = new CFOFormColorChangeAction(GetCurrentModel(),GetCurrentModel()->GetSizeFormShape(),crBack,crText);
			GetCurrentModel()->Do(pCmd,TRUE);
		}
		
	}
}

void CCustomMSampleView::OnUpdateBackColor(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCustomMSampleView::OnTextColor() 
{
	// TODO: Add your command handler code here
	if(m_listSelectComp.GetCount() == 1)
	{
        CFODrawShape *pObj = GetCurrentSelectShape();
        if(pObj != NULL)
        {
			COLORREF crText;
			COLORREF crBack;
			crBack = pObj->GetBkColor();
			CColorDialog dlg(pObj->GetFontColor(), CC_FULLOPEN | CC_ANYCOLOR);
			if(dlg.DoModal() == IDOK)
			{
				crText = dlg.GetColor();
				CFOColorChangeAction* pCmd = new CFOColorChangeAction(GetCurrentModel(),pObj,crBack,crText);
				GetCurrentModel()->Do(pCmd,TRUE);
			}
        }
	}
	else if(m_listSelectComp.GetCount() < 1)
	{
		COLORREF crText;
		COLORREF crBack;
		crBack = GetCurrentModel()->GetBkColor();
		CColorDialog dlg(GetCurrentModel()->GetFontColor(), CC_FULLOPEN | CC_ANYCOLOR);
		if(dlg.DoModal() == IDOK)
		{
			crText = dlg.GetColor();
			CFOFormColorChangeAction* pCmd = new CFOFormColorChangeAction(GetCurrentModel(),GetCurrentModel()->GetSizeFormShape(),crBack,crText);
			GetCurrentModel()->Do(pCmd,TRUE);
		}
	}
}

void CCustomMSampleView::OnUpdateTextColor(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void CCustomMSampleView::OnNewShape() 
{
	// TODO: Add your command handler code here
	m_drawshape = MY_LINE_TYPE;
	FOSetCursor(IDC_FO_DRAW_COMP_CURSOR);
	m_action_state = State_DrawRect;
}

void CCustomMSampleView::OnUpdateNewShape(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_drawshape == MY_LINE_TYPE);
}
