#if !defined(AFX_FOBASECHILDFRAME_H__4BA5F167_F64D_11DD_A43B_525400EA266C__INCLUDED_)
#define AFX_FOBASECHILDFRAME_H__4BA5F167_F64D_11DD_A43B_525400EA266C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FOBaseChildFrame.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFOBaseChildFrame frame

class CFOBaseChildFrame : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CFOBaseChildFrame)
public:
	CFOBaseChildFrame();
	
	// Attributes
private:
	CSplitterWnd* m_pwndSplitter;
	CSplitterWnd* m_pwndSplitter1;
	int m_nStato;
	CRuntimeClass** m_pClass;
	int m_nClass;
	CRuntimeClass* m_pDefaultView;
private:
	BOOL RebuildSpitter();
public:
	// Operations
	void ConfigViews(CRuntimeClass** pviews,int nviews,int InitialStato);
public:
	
	// Overrides
protected:
	virtual void OnConfigViews();
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFOBaseChildFrame)
public:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	//}}AFX_VIRTUAL
	
	// Implementation
public:
	virtual ~CFOBaseChildFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	
	// Generated message map functions
protected:
	//{{AFX_MSG(CFOBaseChildFrame)
	afx_msg void OnSplitterUno();
	afx_msg void OnUpdateSplitterUno(CCmdUI* pCmdUI);
	afx_msg void OnSplitterNessuno();
	afx_msg void OnUpdateSplitterNessuno(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FOBASECHILDFRAME_H__4BA5F167_F64D_11DD_A43B_525400EA266C__INCLUDED_)
